const
 CopyRight = 'ArcId 1.04 - Copyright (C) 1994 - 1997  QuickSoft';
 Formats   = 'Formats: Ain, Arc, Arj, HA, Hap, Hpk, Hyp, Lzh, Pak, Rar'+#13#10+
             '         Sar, SQZ, Uc2, Zip, Zoo';

Type
  ArcType = (Unknown, Ain, Arc, Arj, Ha, Hap, Hpk, Hyp, Lzh, Pak, Rar, Sar, SQZ, Uc2, Zip, Zoo);

  procedure Help;
  begin
   Writeln;
   Writeln(Copyright);
   Writeln(Formats);
   Writeln;
   Writeln('Usage: ArcID <Filename> [/D|/?]');
   Writeln;
   Write   ('Ain',Ord(Ain):15,'  ');
   Writeln ('Arc',Ord(Arc):15,'  ');
   Write   ('Arj',Ord(Arj):15,'  ');
   Writeln ('Ha ',Ord(Ha):15,'  ');
   Write   ('Hap',Ord(Hap):15,'  ');
   Writeln ('Hpk',Ord(Hpk):15,'  ');
   Write   ('Hyp',Ord(Hyp):15,'  ');
   Writeln  ('Lzh',Ord(Lzh):15,'  ');
   Write   ('Pak',Ord(Pak):15,'  ');
   Writeln   ('Rar',Ord(Rar):15,'  ');
   Write   ('Sar',Ord(Sar):15,'  ');
   Writeln   ('Sqz',Ord(SQZ):15,'  ');
   Write   ('Uc2',Ord(Uc2):15,'  ');
   Writeln   ('Zip',Ord(Zip):15,'  ');
   Write  ('Zoo',Ord(Zoo):15,'  ');
   Writeln ('Unknown = ',Ord(Unknown):8,'  ');
   Writeln;
   Writeln('/? This help screen',#13#10,
           '/D Debug output');

   Halt(255);
  end;

procedure Error(FName: String);
begin
 Writeln('File Error -> ',FName);
 Halt(255);
end;

Function GetArcType(FName : String) : ArcType;
Var
  ArcFile : File of Byte;
  i       : Integer;
  Gat     : ArcType;
  c       : Array[1..5] of Byte;
begin
  Assign(ArcFile, FName);
  {$I-}
  Reset(ArcFile);
  {$I+}
  if IOResult <> 0 then
    Error(FName)
  else
  if FileSize(ArcFile) < 5 then
   Error(FName)
  else
  begin
    For i := 1 to 5 do
      Read(ArcFile, c[i]);
    Close(ArcFile);
    if ((c[1] = $50) and (c[2] = $4B)) then
      Gat := Zip
    else
    if ((c[1] = $60) and (c[2] = $EA)) then
      Gat := Arj
    else
    if ((c[4] = $6c) and (c[5] = $68)) then
      Gat := Lzh
    else
    if ((c[1] = $5a) and (c[2] = $4f) and (c[3] = $4f)) then
      Gat := Zoo
    else
    if ((c[1] = $1a) and (c[2] = $08)) then
      Gat := Arc
    else
    if ((c[1] = $1a) and (c[2] = $0b)) then
      Gat := Pak
    else
    if ((c[1] = $55) and (c[2] = $43)) then
      Gat := UC2
    else
      if ((c[1] = $52) and (c[2] = $61)  and (c[3] = $72)) then
      Gat := RAR
    else
     if ((c[1] = $91) and (c[2] = $33)  and (c[3] = $48)) then
      Gat := HAP
    else
     if (c[1] = $21) then
      Gat := AIN
    else
      if ((c[1] = $48) and (c[2] = $4C)  and (c[3] = $53) and (c[4] = $51) and (c[5] = $5A)) then
      Gat :=SQZ
    else
      if ((c[1] = $48) and (c[2] = $50)  and (c[3] = $41) and (c[4] = $4b)) then
      Gat :=HPK
    else
      if ((c[4] = $4C) and (c[5] = $48)) then
      Gat :=SAR
    else
    if ((c[2]=Byte('S')) and (c[3]=Byte('T')) or (c[2]=Byte('H')) and (c[3]=Byte('P'))) then
      Gat :=HYP
     else
     if ((c[1]=Byte('H')) and (c[2]=Byte('A'))) then
      Gat :=HA
     else
      Gat := Unknown;
  end;
  GetArcType := Gat;
end;

Var
  FileName : String;
  Return   : ArcType;

begin
 if ParamCount >= 1 then
 begin
   If Pos('?',ParamStr(1)) <> 0 then Help;
   FileName := ParamStr(1);
   Return   := GetArcType(FileName);
   if (ParamStr(2)='/D') or (ParamStr(2)='/d') then
   begin
    Writeln(Copyright);
   Case Return of
     ARJ     : Writeln('ARJ');
     PAK     : Writeln('PAK');
     LZH     : Writeln('LZH');
     ARC     : Writeln('ARC');
     ZOO     : Writeln('ZOO');
     ZIP     : Writeln('ZIP');
     UC2     : Writeln('UC2');
     RAR     : Writeln('RAR');
     HAP     : Writeln('HAP');
     AIN     : Writeln('AIN');
     SQZ     : Writeln('SQZ');
     HPK     : Writeln('HPK');
     SAR     : Writeln('SAR');
     HYP     : Writeln('HYP');
     HA      : Writeln('HA');
     UNKNOWN : Writeln('Unknown')
     else
     Writeln('File Not Found');
   end;
  end;
  Halt(Ord(ArcType(Return)));
 end {IF}
  else
    Help;
end.
